"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }// src/index.ts
var _kit = require('@nuxt/kit');
var _vite = require('unplugin-vue-macros/vite'); var _vite2 = _interopRequireDefault(_vite);
var _unpluginvuemacros = require('unplugin-vue-macros');
var _common = require('@vue-macros/common');
var src_default = _kit.defineNuxtModule.call(void 0, {
  meta: {
    name: "unplugin-vue-macros",
    configKey: "macros"
  },
  defaults: {},
  setup(options) {
    const nuxt = _kit.useNuxt.call(void 0, );
    const resolvedOptions = _unpluginvuemacros.resolveOptions.call(void 0, options);
    nuxt.hook("vite:extendConfig", (config, { isClient }) => {
      function findPluginAndRemove(name) {
        const idx = config.plugins.findIndex(
          (plugin2) => plugin2 && "name" in plugin2 && plugin2.name === name
        );
        if (idx === -1)
          return;
        const plugin = config.plugins[idx];
        config.plugins.splice(idx, 1);
        return plugin;
      }
      config.plugins ||= [];
      const vue = findPluginAndRemove("vite:vue");
      const vueJsx = findPluginAndRemove("vite:vue-jsx");
      config.plugins.push(
        _vite2.default.call(void 0, {
          ...resolvedOptions,
          plugins: { vue, vueJsx },
          nuxtContext: { isClient }
        })
      );
    });
    nuxt.hook("prepare:types", (opts) => {
      opts.references.push({ types: "unplugin-vue-macros/macros-global" });
    });
    nuxt.hook("devtools:customTabs", (tabs) => {
      tabs.push({
        name: "vue-macros",
        title: "Vue Macros",
        icon: `https://raw.githubusercontent.com/${"vue-macros/vue-macros"}/main/docs/public/favicon.svg`,
        view: {
          type: "iframe",
          src: "/__vue-macros"
        }
      });
    });
    nuxt.options.typescript.tsConfig ||= {};
    nuxt.options.typescript.tsConfig.vueCompilerOptions ||= {};
    const vueCompilerOptions = (
      // @ts-expect-error
      nuxt.options.typescript.tsConfig.vueCompilerOptions
    );
    vueCompilerOptions.vueMacros ||= {};
    const volarOptions = vueCompilerOptions.vueMacros;
    vueCompilerOptions.plugins ||= [];
    const volarPlugins = vueCompilerOptions.plugins;
    if (resolvedOptions.defineOptions)
      volarPlugins.push("@vue-macros/volar/define-options");
    if (resolvedOptions.defineSlots)
      volarPlugins.push("@vue-macros/volar/define-slots");
    if (resolvedOptions.defineModels)
      volarPlugins.push("@vue-macros/volar/define-models");
    if (resolvedOptions.defineProps)
      volarPlugins.push("@vue-macros/volar/define-props");
    if (resolvedOptions.definePropsRefs)
      volarPlugins.push("@vue-macros/volar/define-props-refs");
    if (resolvedOptions.exportProps)
      volarPlugins.push("@vue-macros/volar/export-props");
    if (resolvedOptions.jsxDirective)
      volarPlugins.push("@vue-macros/volar/jsx-directive");
    if (resolvedOptions.defineProp)
      vueCompilerOptions.experimentalDefinePropProposal = resolvedOptions.defineProp.edition || "kevinEdition";
    if (resolvedOptions.shortBind)
      volarPlugins.push("@vue-macros/volar/short-bind");
    if (resolvedOptions.shortVmodel) {
      volarPlugins.push("@vue-macros/volar/short-vmodel");
      volarOptions.shortVmodel = {
        prefix: resolvedOptions.shortVmodel.prefix
      };
    }
    const viteVue = nuxt.options.vite.vue ||= {};
    if (resolvedOptions.setupSFC) {
      viteVue.include ||= [/\.vue$/];
      if (!Array.isArray(viteVue.include))
        viteVue.include = [viteVue.include];
      viteVue.include.push(_common.REGEX_SETUP_SFC);
      nuxt.hook("components:extend", (components) => {
        for (const component of components) {
          component.pascalName = component.pascalName.replace(/Setup$/, "");
          component.kebabName = component.kebabName.replace(/-setup$/, "");
        }
      });
      nuxt.hook("pages:extend", (pages) => {
        for (const page of pages) {
          if (!page.file || !_common.REGEX_SETUP_SFC.test(page.file))
            continue;
          if (page.name)
            page.name = page.name.replace(/\.setup$/, "");
          if (page.path)
            page.path = page.path.replace(/\/index\.setup$/, "/").replace(/\.setup$/, "");
        }
      });
    }
    nuxt.hook("app:resolve", (app) => {
      app.layouts = Object.fromEntries(
        Object.entries(app.layouts).map(([key, value]) => {
          if (key.endsWith("-setup")) {
            key = key.replace(/-setup$/, "");
            value.name = value.name.replace(/-setup$/, "");
          }
          return [key, value];
        })
      );
    });
  }
});


exports.default = src_default;

module.exports = exports.default;
